########################
## {{ ansible_managed }}

upstream dns-over-https-ads {
    server 127.0.0.1:8054;
}

upstream dns-over-https {
    server 127.0.0.1:8053;
}

server {
    listen 80;
    listen [::]:80;
    server_name doh.{{ DOMAIN }};

    return 301 https://{{ DOMAIN }}$request_uri;
}

server {
    listen 443 ssl http2;
    listen [::]:443 ssl http2;
    server_name  doh.{{ DOMAIN }};

    ssl_certificate /root/.acme.sh/{{ DOMAIN }}/fullchain.cer;
    ssl_certificate_key /root/.acme.sh/{{ DOMAIN }}/{{ DOMAIN }}.key;

    location / {
        return 301 https://{{ DOMAIN }}$request_uri;
    }

    location /ads {
        proxy_set_header Host $host;
        proxy_set_header X-Real-IP $remote_addr;
        proxy_pass http://dns-over-https-ads/ads;
    }

    location /noads {
        proxy_set_header Host $host;
        proxy_set_header X-Real-IP $remote_addr;
        proxy_pass http://dns-over-https-ads/ads;
    }

    location /dns-query {
        proxy_set_header Host $host;
        proxy_set_header X-Real-IP $remote_addr;
        proxy_pass http://dns-over-https/dns-query;
    }
}
